=== doc/Makefile ===
doc:
	cd ..; make doc ; cd doc
