=== demo/random-noise/Makefile ===

all::
	@echo === This demo is interactive: hit enter to move to next step
	./vw-demo
