=== debian/changelog ===
vowpal-wabbit (8.6.1.dfsg1-1~nd18.04+1) bionic; urgency=medium

  * Backported for bionic.
  * Used following sed expression to modify debian/control: -e
    's/\(^Depends:\) */\1 neurodebian-popularity-contest, /g' -e
    's/^Maintainer:.*$/Maintainer: NeuroDebian Maintainers
    <team@neuro.debian.net>\nX-Original-&/'.

 -- NeuroDebian Maintainers <team@neuro.debian.net>  Fri, 27 Jul 2018 22:10:28 -0400

vowpal-wabbit (8.6.1.dfsg1-1) unstable; urgency=medium

  * Fresh upstream release
  * debian/patches
    + deb_skip_42 to skip test 42 for now since fails on some 32bit 
      elderlies https://github.com/JohnLangford/vowpal_wabbit/issues/1553

 -- Yaroslav Halchenko <debian@onerussian.com>  Fri, 27 Jul 2018 19:27:03 -0400

vowpal-wabbit (8.5.0.dfsg1-3) unstable; urgency=medium

  * debian/rules
    - pass the mmx/sse settings only for amd64 and i386 (Closes: #893031)

 -- Yaroslav Halchenko <debian@onerussian.com>  Fri, 16 Mar 2018 15:06:24 -0400

vowpal-wabbit (8.5.0.dfsg1-2) unstable; urgency=medium

  * debian/control
    - add missing markdown and html2text used for README.md generation
  * debian/rules
    - force -msse -mfpmath=sse to provide consistent arithmetics between
      32 and 64 bit x86

 -- Yaroslav Halchenko <debian@onerussian.com>  Sun, 11 Feb 2018 15:19:14 -0500
